731d2ac620ade334a5acd65a9840d1703f56caf9
[doctor.git] / tests / run.sh
1 #!/bin/bash -e
2 ##############################################################################
3 # Copyright (c) 2016 NEC Corporation and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 [[ "${CI_DEBUG:-true}" == [Tt]rue ]] && set -x
12
13 IMAGE_URL=https://launchpad.net/cirros/trunk/0.3.0/+download/cirros-0.3.0-x86_64-disk.img
14 IMAGE_NAME=cirros
15 IMAGE_FILE="${IMAGE_NAME}.img"
16 IMAGE_FORMAT=qcow2
17 VM_NAME=doctor_vm1
18 VM_FLAVOR=m1.tiny
19 ALARM_NAME=doctor_alarm1
20 INSPECTOR_PORT=12345
21 CONSUMER_PORT=12346
22 DOCTOR_USER=doctor
23 DOCTOR_PW=doctor
24 DOCTOR_PROJECT=doctor
25 #TODO: change back to `_member_` when JIRA DOCTOR-55 is done
26 DOCTOR_ROLE=admin
27
28 SUPPORTED_INSTALLER_TYPES="apex fuel local"
29 INSTALLER_TYPE=${INSTALLER_TYPE:-local}
30 INSTALLER_IP=${INSTALLER_IP:-none}
31
32 ssh_opts="-o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no"
33 as_doctor_user="--os-username $DOCTOR_USER --os-password $DOCTOR_PW
34                 --os-tenant-name $DOCTOR_PROJECT"
35
36 if [[ ! "$SUPPORTED_INSTALLER_TYPES" =~ "$INSTALLER_TYPE" ]] ; then
37     echo "ERROR: INSTALLER_TYPE=$INSTALLER_TYPE is not supported."
38     exit 1
39 fi
40
41 get_compute_host_info() {
42     # get computer host info which VM boot in
43     COMPUTE_HOST=$(openstack $as_doctor_user server show $VM_NAME |
44                    grep "OS-EXT-SRV-ATTR:host" | awk '{ print $4 }')
45     compute_host_in_undercloud=${COMPUTE_HOST%%.*}
46     if [[ -z "$COMPUTE_HOST" ]] ; then
47         echo "ERROR: failed to get compute hostname"
48         exit 1
49     fi
50
51     if [[ "$INSTALLER_TYPE" == "apex" ]] ; then
52         COMPUTE_USER=${COMPUTE_USER:-heat-admin}
53         if [[ "$INSTALLER_IP" == "none" ]] ; then
54             instack_mac=$(sudo virsh domiflist instack | awk '/default/{print $5}')
55             INSTALLER_IP=$(/usr/sbin/arp -e | grep ${instack_mac} | awk '{print $1}')
56         fi
57         COMPUTE_IP=$(sudo ssh $ssh_opts $INSTALLER_IP \
58              "source stackrc; \
59              nova show $compute_host_in_undercloud \
60              | awk '/ ctlplane network /{print \$5}'")
61     elif [[ "$INSTALLER_TYPE" == "fuel" ]] ; then
62         COMPUTE_USER=${COMPUTE_USER:-root}
63         if [[ "$INSTALLER_IP" == "none" ]] ; then
64             instack_mac=$(sudo virsh domiflist fuel-opnfv | awk '/pxebr/{print $5}')
65             INSTALLER_IP=$(/usr/sbin/arp -e | grep ${instack_mac} | awk '{print $1}')
66         fi
67         node_id=$(echo $compute_host_in_undercloud | cut -d "-" -f 2)
68         COMPUTE_IP=$(sshpass -p r00tme ssh 2>/dev/null $ssh_opts root@${INSTALLER_IP} \
69              "fuel node|awk -F '|' -v id=$node_id '{if (\$1 == id) print \$5}' |xargs")
70     elif [[ "$INSTALLER_TYPE" == "local" ]] ; then
71         COMPUTE_USER=${COMPUTE_USER:-$(whoami)}
72         COMPUTE_IP=$(getent hosts "$COMPUTE_HOST" | awk '{ print $1 }')
73     fi
74
75     if [[ -z "$COMPUTE_IP" ]]; then
76         echo "ERROR: Could not resolve $COMPUTE_HOST. Either manually set COMPUTE_IP or enable DNS resolution."
77         exit 1
78     fi
79     echo "COMPUTE_HOST=$COMPUTE_HOST"
80     echo "COMPUTE_IP=$COMPUTE_IP"
81
82     # verify connectivity to target compute host
83     ping -c 1 "$COMPUTE_IP"
84     if [[ $? -ne 0 ]] ; then
85         echo "ERROR: can not ping to computer host"
86         exit 1
87     fi
88 }
89
90 prepare_compute_ssh() {
91     ssh_opts_cpu="$ssh_opts"
92
93     # get ssh key from installer node
94     if [[ "$INSTALLER_TYPE" == "apex" ]] ; then
95         sudo scp $ssh_opts root@"$INSTALLER_IP":/home/stack/.ssh/id_rsa instack_key
96         sudo chown $(whoami):$(whoami) instack_key
97         chmod 400 instack_key
98         ssh_opts_cpu+=" -i instack_key"
99     elif [[ "$INSTALLER_TYPE" == "fuel" ]] ; then
100         sshpass -p r00tme scp $ssh_opts root@${INSTALLER_IP}:.ssh/id_rsa instack_key
101         sudo chown $(whoami):$(whoami) instack_key
102         chmod 400 instack_key
103         ssh_opts_cpu+=" -i instack_key"
104     elif [[ "$INSTALLER_TYPE" == "local" ]] ; then
105         echo "INSTALLER_TYPE set to 'local'. Assuming SSH keys already exchanged with $COMPUTE_HOST"
106     fi
107
108     # verify ssh to target compute host
109     ssh $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP" 'exit'
110     if [[ $? -ne 0 ]] ; then
111         echo "ERROR: can not ssh to computer host"
112         exit 1
113     fi
114 }
115
116 get_consumer_ip() {
117     CONSUMER_IP=$(sudo ssh $ssh_opts root@$INSTALLER_IP \
118                   "ip route get $COMPUTE_IP | awk '/ src /{print \$NF}'")
119     echo "CONSUMER_IP=$CONSUMER_IP"
120
121     if [[ -z "$CONSUMER_IP" ]]; then
122         echo "ERROR: Could not get CONSUMER_IP."
123         exit 1
124     fi
125 }
126
127 download_image() {
128     [ -e "$IMAGE_FILE" ] && return 0
129     wget "$IMAGE_URL" -o "$IMAGE_FILE"
130 }
131
132 register_image() {
133     openstack image list | grep -q " $IMAGE_NAME " && return 0
134     openstack image create "$IMAGE_NAME" \
135                            --public \
136                            --disk-format "$IMAGE_FORMAT" \
137                            --container-format bare \
138                            --file "$IMAGE_FILE"
139 }
140
141 create_test_user() {
142     openstack user list | grep -q " $DOCTOR_USER " || {
143         openstack user create "$DOCTOR_USER" --password "$DOCTOR_PW"
144     }
145     openstack project list | grep -q " $DOCTOR_PROJECT " || {
146         openstack project create "$DOCTOR_PROJECT"
147     }
148     openstack user role list "$DOCTOR_USER" --project "$DOCTOR_PROJECT" \
149     | grep -q " $DOCTOR_ROLE " || {
150         openstack role add "$DOCTOR_ROLE" --user "$DOCTOR_USER" \
151                            --project "$DOCTOR_PROJECT"
152     }
153 }
154
155 boot_vm() {
156     # test VM done with test user, so can test non-admin
157     openstack $as_doctor_user server list | grep -q " $VM_NAME " && return 0
158     openstack $as_doctor_user server create --flavor "$VM_FLAVOR" \
159                             --image "$IMAGE_NAME" \
160                             "$VM_NAME"
161     sleep 1
162 }
163
164 create_alarm() {
165     # get vm_id as test user
166     ceilometer $as_doctor_user alarm-list | grep -q " $ALARM_NAME " && return 0
167     vm_id=$(openstack $as_doctor_user server list | grep " $VM_NAME " | awk '{print $2}')
168     ceilometer $as_doctor_user alarm-event-create --name "$ALARM_NAME" \
169         --alarm-action "http://$CONSUMER_IP:$CONSUMER_PORT/failure" \
170         --description "VM failure" \
171         --enabled True \
172         --repeat-actions False \
173         --severity "moderate" \
174         --event-type compute.instance.update \
175         -q "traits.state=string::error; traits.instance_id=string::$vm_id"
176 }
177
178 print_log() {
179     log_file=$1
180     echo "$log_file:"
181     sed -e 's/^/    /' "$log_file"
182 }
183
184 start_monitor() {
185     pgrep -f "python monitor.py" && return 0
186     sudo python monitor.py "$COMPUTE_HOST" "$COMPUTE_IP" \
187         "http://127.0.0.1:$INSPECTOR_PORT/events" > monitor.log 2>&1 &
188 }
189
190 stop_monitor() {
191     pgrep -f "python monitor.py" || return 0
192     sudo kill $(pgrep -f "python monitor.py")
193     print_log monitor.log
194 }
195
196 start_inspector() {
197     pgrep -f "python inspector.py" && return 0
198     python inspector.py "$INSPECTOR_PORT" > inspector.log 2>&1 &
199 }
200
201 stop_inspector() {
202     pgrep -f "python inspector.py" || return 0
203     kill $(pgrep -f "python inspector.py")
204     print_log inspector.log
205 }
206
207 start_consumer() {
208     pgrep -f "python consumer.py" && return 0
209     python consumer.py "$CONSUMER_PORT" > consumer.log 2>&1 &
210     # NOTE(r-mibu): create tunnel to the installer node, so that we can
211     # avoid some network problems dpends on infra and installers.
212     # This tunnel will be terminated by stop_consumer() or after 10 mins passed.
213     TUNNEL_COMMAND="sudo ssh $ssh_opts $INSTALLER_IP -R $CONSUMER_PORT:localhost:$CONSUMER_PORT 'sleep 600'"
214     $TUNNEL_COMMAND > ssh_tunnel.log 2>&1 < /dev/null &
215 }
216
217 stop_consumer() {
218     pgrep -f "python consumer.py" || return 0
219     kill $(pgrep -f "python consumer.py")
220     print_log consumer.log
221     kill $(pgrep -f "$TUNNEL_COMMAND")
222     print_log ssh_tunnel.log
223 }
224
225 wait_for_vm_launch() {
226     echo "waiting for vm launch..."
227
228     count=0
229     while [[ ${count} -lt 60 ]]
230     do
231         state=$(openstack $as_doctor_user server list | grep " $VM_NAME " | awk '{print $6}')
232         [[ "$state" == "ACTIVE" ]] && return 0
233         [[ "$state" == "ERROR" ]] && echo "vm state is ERROR" && exit 1
234         count=$(($count+1))
235         sleep 1
236     done
237     echo "ERROR: time out while waiting for vm launch"
238     exit 1
239 }
240
241 inject_failure() {
242     echo "disabling network of compute host [$COMPUTE_HOST] for 3 mins..."
243     cat > disable_network.sh << 'END_TXT'
244 #!/bin/bash -x
245 dev=$(sudo ip a | awk '/ @COMPUTE_IP@\//{print $7}')
246 sleep 1
247 sudo ip link set $dev down
248 sleep 180
249 sudo ip link set $dev up
250 sleep 1
251 END_TXT
252     sed -i -e "s/@COMPUTE_IP@/$COMPUTE_IP/" disable_network.sh
253     chmod +x disable_network.sh
254     scp $ssh_opts_cpu disable_network.sh "$COMPUTE_USER@$COMPUTE_IP:"
255     ssh $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP" 'nohup ./disable_network.sh > disable_network.log 2>&1 &'
256 }
257
258 calculate_notification_time() {
259     detected=$(grep "doctor monitor detected at" monitor.log | awk '{print $5}')
260     notified=$(grep "doctor consumer notified at" consumer.log | awk '{print $5}')
261     if ! grep -q "doctor consumer notified at" consumer.log ; then
262         echo "ERROR: consumer hasn't received fault notification."
263         exit 1
264     fi
265     echo "$notified $detected" | \
266         awk '{d = $1 - $2; if (d < 1 && d > 0) print d " OK"; else print d " NG"}'
267 }
268
269 check_host_status() {
270     expected_state=$1
271
272     host_status_line=$(openstack $as_doctor_user --os-compute-api-version 2.16 \
273                        server show $VM_NAME | grep "host_status")
274     host_status=$(echo $host_status_line | awk '{print $4}')
275     if [ -z "$host_status" ] ; then
276         echo "ERROR: host_status not reported by: nova show $VM_NAME"
277         exit 1
278     elif [[ "$expected_state" =~ "$host_status" ]] ; then
279         echo "$VM_NAME showing host_status: $host_status"
280     else
281         echo "ERROR: host_status:$host_status not equal to expected_state: $expected_state"
282         exit 1
283     fi
284 }
285
286 cleanup() {
287     set +e
288     echo "cleanup..."
289     stop_monitor
290     stop_inspector
291     stop_consumer
292
293     echo "waiting disabled compute host back to be enabled..."
294     python ./nova_force_down.py "$COMPUTE_HOST" --unset
295     sleep 240
296     check_host_status "UP"
297     scp $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP:disable_network.log" .
298     print_log disable_network.log
299
300     openstack $as_doctor_user server list | grep -q " $VM_NAME " && openstack $as_doctor_user server delete "$VM_NAME"
301     sleep 1
302     alarm_id=$(ceilometer $as_doctor_user alarm-list | grep " $ALARM_NAME " | awk '{print $2}')
303     sleep 1
304     [ -n "$alarm_id" ] && ceilometer $as_doctor_user alarm-delete "$alarm_id"
305     sleep 1
306
307     image_id=$(openstack image list | grep " $IMAGE_NAME " | awk '{print $2}')
308     sleep 1
309     [ -n "$image_id" ] && openstack image delete "$image_id"
310     openstack role remove "$DOCTOR_ROLE" --user "$DOCTOR_USER" \
311                               --project "$DOCTOR_PROJECT"
312     openstack project delete "$DOCTOR_PROJECT"
313     openstack user delete "$DOCTOR_USER"
314 }
315
316
317 echo "Note: doctor/tests/run.sh has been executed."
318
319 trap cleanup EXIT
320
321 echo "preparing VM image..."
322 download_image
323 register_image
324
325 echo "creating test user..."
326 create_test_user
327
328 echo "creating VM..."
329 boot_vm
330 wait_for_vm_launch
331 openstack $as_doctor_user server show $VM_NAME
332
333 echo "get computer host info and prepare to ssh..."
334 get_compute_host_info
335 prepare_compute_ssh
336
337 echo "creating alarm..."
338 get_consumer_ip
339 create_alarm
340
341 echo "starting doctor sample components..."
342 start_monitor
343 start_inspector
344 start_consumer
345
346 sleep 60
347 echo "injecting host failure..."
348 inject_failure
349 sleep 60
350
351 check_host_status "(DOWN|UNKNOWN)"
352 calculate_notification_time
353
354 echo "done"